package pps.core.space.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import pps.core.space.mapper.*;
import pps.core.space.entity.*;
import pps.core.space.service.data.space_institution_duration.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import hz.core.base.helper.MapperHelper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import java.util.List;

@XService
public class SpaceInstitutionDurationService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createSpaceInstitutionDuration(XContext context, CreateSpaceInstitutionDurationInput input){
        SpaceInstitutionDurationMapper mapper = context.getBean(SpaceInstitutionDurationMapper.class);
        SpaceInstitutionDurationEnt entity = new SpaceInstitutionDurationEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateSpaceInstitutionDuration(XContext context, UpdateSpaceInstitutionDurationInput input){
        SpaceInstitutionDurationMapper mapper = context.getBean(SpaceInstitutionDurationMapper.class);
        QueryWrapper<SpaceInstitutionDurationEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceInstitutionDurationEnt::getId, input.getId());
        SpaceInstitutionDurationEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteSpaceInstitutionDuration(XContext context, DeleteSpaceInstitutionDurationInput input){
        SpaceInstitutionDurationMapper mapper = context.getBean(SpaceInstitutionDurationMapper.class);
        QueryWrapper<SpaceInstitutionDurationEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceInstitutionDurationEnt::getId, input.getId());
        SpaceInstitutionDurationEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceInstitutionDurationOutput> getSpaceInstitutionDuration(XContext context, GetSpaceInstitutionDurationInput input){
        SpaceInstitutionDurationMapper mapper = context.getBean(SpaceInstitutionDurationMapper.class);
        QueryWrapper<SpaceInstitutionDurationEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceInstitutionDurationEnt::getId, input.getId());
        SpaceInstitutionDurationEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceInstitutionDurationOutput output = new GetSpaceInstitutionDurationOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceInstitutionDurationOutput> querySpaceInstitutionDuration(XContext context, QuerySpaceInstitutionDurationInput input){
        SpaceInstitutionDurationMapper mapper = context.getBean(SpaceInstitutionDurationMapper.class);
        QueryWrapper<SpaceInstitutionDurationEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(SpaceInstitutionDurationEnt::getId, input.getId())
            .eq(SpaceInstitutionDurationEnt::getIsDeleted, input.getIsDeleted())
            .like(SpaceInstitutionDurationEnt::getCreateById, input.getCreateById())
            .like(SpaceInstitutionDurationEnt::getCreateByName, input.getCreateByName())
            .eq(SpaceInstitutionDurationEnt::getCreateTime, input.getCreateTime())
            .like(SpaceInstitutionDurationEnt::getModifyById, input.getModifyById())
            .like(SpaceInstitutionDurationEnt::getModifyByName, input.getModifyByName())
            .eq(SpaceInstitutionDurationEnt::getModifyTime, input.getModifyTime())
            .like(SpaceInstitutionDurationEnt::getInstitutionId, input.getInstitutionId())
            .like(SpaceInstitutionDurationEnt::getConfigId, input.getConfigId())
            .like(SpaceInstitutionDurationEnt::getWellheadId, input.getWellheadId())
            .like(SpaceInstitutionDurationEnt::getGenerationTypeKey, input.getGenerationTypeKey())
            .like(SpaceInstitutionDurationEnt::getOpenWellTime, input.getOpenWellTime())
            .like(SpaceInstitutionDurationEnt::getCloseWellTime, input.getCloseWellTime());
        return MapperHelper.query(mapper, input, queryWrapper, QuerySpaceInstitutionDurationOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceInstitutionDurationOutput> dynamicQuerySpaceInstitutionDuration(XContext context, CustomQueryInput input){
        SpaceInstitutionDurationMapper mapper = context.getBean(SpaceInstitutionDurationMapper.class);
        return MapperHelper.query(mapper, input, SpaceInstitutionDurationEnt.class, QuerySpaceInstitutionDurationOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceInstitutionDurationViewOutput> getSpaceInstitutionDurationView(XContext context, GetSpaceInstitutionDurationViewInput input){
        SpaceInstitutionDurationViewMapper mapper = context.getBean(SpaceInstitutionDurationViewMapper.class);
        SpaceInstitutionDurationView record = new SpaceInstitutionDurationView();
        XCopyUtils.copyObject(input, record);
        SpaceInstitutionDurationView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceInstitutionDurationViewOutput output = new GetSpaceInstitutionDurationViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceInstitutionDurationViewOutput> querySpaceInstitutionDurationView(XContext context, QuerySpaceInstitutionDurationViewInput input){
        SpaceInstitutionDurationViewMapper mapper = context.getBean(SpaceInstitutionDurationViewMapper.class);
        SpaceInstitutionDurationView record = new SpaceInstitutionDurationView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<SpaceInstitutionDurationView> list = mapper.selectList(record);
        PageInfo<SpaceInstitutionDurationView> pageInfo = new PageInfo<>(list);
        List<QuerySpaceInstitutionDurationViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QuerySpaceInstitutionDurationViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
