package pps.core.space.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import pps.core.space.mapper.*;
import pps.core.space.entity.*;
import pps.core.space.service.data.space_institution_institution.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import hz.core.base.helper.MapperHelper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import java.util.List;

@XService
public class SpaceInstitutionInstitutionService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createSpaceInstitutionInstitution(XContext context, CreateSpaceInstitutionInstitutionInput input){
        SpaceInstitutionInstitutionMapper mapper = context.getBean(SpaceInstitutionInstitutionMapper.class);
        SpaceInstitutionInstitutionEnt entity = new SpaceInstitutionInstitutionEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateSpaceInstitutionInstitution(XContext context, UpdateSpaceInstitutionInstitutionInput input){
        SpaceInstitutionInstitutionMapper mapper = context.getBean(SpaceInstitutionInstitutionMapper.class);
        QueryWrapper<SpaceInstitutionInstitutionEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceInstitutionInstitutionEnt::getId, input.getId());
        SpaceInstitutionInstitutionEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteSpaceInstitutionInstitution(XContext context, DeleteSpaceInstitutionInstitutionInput input){
        SpaceInstitutionInstitutionMapper mapper = context.getBean(SpaceInstitutionInstitutionMapper.class);
        QueryWrapper<SpaceInstitutionInstitutionEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceInstitutionInstitutionEnt::getId, input.getId());
        SpaceInstitutionInstitutionEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceInstitutionInstitutionOutput> getSpaceInstitutionInstitution(XContext context, GetSpaceInstitutionInstitutionInput input){
        SpaceInstitutionInstitutionMapper mapper = context.getBean(SpaceInstitutionInstitutionMapper.class);
        QueryWrapper<SpaceInstitutionInstitutionEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceInstitutionInstitutionEnt::getId, input.getId());
        SpaceInstitutionInstitutionEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceInstitutionInstitutionOutput output = new GetSpaceInstitutionInstitutionOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceInstitutionInstitutionOutput> querySpaceInstitutionInstitution(XContext context, QuerySpaceInstitutionInstitutionInput input){
        SpaceInstitutionInstitutionMapper mapper = context.getBean(SpaceInstitutionInstitutionMapper.class);
        QueryWrapper<SpaceInstitutionInstitutionEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(SpaceInstitutionInstitutionEnt::getId, input.getId())
            .eq(SpaceInstitutionInstitutionEnt::getIsDeleted, input.getIsDeleted())
            .like(SpaceInstitutionInstitutionEnt::getCreateById, input.getCreateById())
            .like(SpaceInstitutionInstitutionEnt::getCreateByName, input.getCreateByName())
            .eq(SpaceInstitutionInstitutionEnt::getCreateTime, input.getCreateTime())
            .like(SpaceInstitutionInstitutionEnt::getModifyById, input.getModifyById())
            .like(SpaceInstitutionInstitutionEnt::getModifyByName, input.getModifyByName())
            .eq(SpaceInstitutionInstitutionEnt::getModifyTime, input.getModifyTime())
            .like(SpaceInstitutionInstitutionEnt::getOuId, input.getOuId())
            .like(SpaceInstitutionInstitutionEnt::getLineId, input.getLineId())
            .like(SpaceInstitutionInstitutionEnt::getGridTypeKey, input.getGridTypeKey())
            .like(SpaceInstitutionInstitutionEnt::getInstitutionName, input.getInstitutionName())
            .eq(SpaceInstitutionInstitutionEnt::getInstitutionStartDate, input.getInstitutionStartDate())
            .eq(SpaceInstitutionInstitutionEnt::getInstitutionEndDate, input.getInstitutionEndDate())
            .eq(SpaceInstitutionInstitutionEnt::getOptimizeDeadline, input.getOptimizeDeadline())
            .eq(SpaceInstitutionInstitutionEnt::getOptimizeState, input.getOptimizeState())
            .eq(SpaceInstitutionInstitutionEnt::getIsCurrentBasic, input.getIsCurrentBasic())
            .eq(SpaceInstitutionInstitutionEnt::getStartInterval, input.getStartInterval());
        return MapperHelper.query(mapper, input, queryWrapper, QuerySpaceInstitutionInstitutionOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceInstitutionInstitutionOutput> dynamicQuerySpaceInstitutionInstitution(XContext context, CustomQueryInput input){
        SpaceInstitutionInstitutionMapper mapper = context.getBean(SpaceInstitutionInstitutionMapper.class);
        return MapperHelper.query(mapper, input, SpaceInstitutionInstitutionEnt.class, QuerySpaceInstitutionInstitutionOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceInstitutionInstitutionViewOutput> getSpaceInstitutionInstitutionView(XContext context, GetSpaceInstitutionInstitutionViewInput input){
        SpaceInstitutionInstitutionViewMapper mapper = context.getBean(SpaceInstitutionInstitutionViewMapper.class);
        SpaceInstitutionInstitutionView record = new SpaceInstitutionInstitutionView();
        XCopyUtils.copyObject(input, record);
        SpaceInstitutionInstitutionView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceInstitutionInstitutionViewOutput output = new GetSpaceInstitutionInstitutionViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceInstitutionInstitutionViewOutput> querySpaceInstitutionInstitutionView(XContext context, QuerySpaceInstitutionInstitutionViewInput input){
        SpaceInstitutionInstitutionViewMapper mapper = context.getBean(SpaceInstitutionInstitutionViewMapper.class);
        SpaceInstitutionInstitutionView record = new SpaceInstitutionInstitutionView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<SpaceInstitutionInstitutionView> list = mapper.selectList(record);
        PageInfo<SpaceInstitutionInstitutionView> pageInfo = new PageInfo<>(list);
        List<QuerySpaceInstitutionInstitutionViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QuerySpaceInstitutionInstitutionViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
