package pps.core.space.service;

import java.util.Date;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import pps.core.space.mapper.*;
import pps.core.space.entity.*;
import pps.core.space.service.data.space_optimize_mid_duration.*;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import xstartup.annotation.XService;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.data.XListResult;
import xstartup.data.XPageResult;
import xstartup.annotation.XText;
import xstartup.base.XContext;
import xstartup.base.util.XCopyUtils;
import xstartup.error.XError;
import xstartup.base.data.CustomQueryInput;
import hz.core.base.helper.MapperHelper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import java.util.List;

@XService
public class SpaceOptimizeMidDurationService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createSpaceOptimizeMidDuration(XContext context, CreateSpaceOptimizeMidDurationInput input){
        SpaceOptimizeMidDurationMapper mapper = context.getBean(SpaceOptimizeMidDurationMapper.class);
        SpaceOptimizeMidDurationEnt entity = new SpaceOptimizeMidDurationEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateSpaceOptimizeMidDuration(XContext context, UpdateSpaceOptimizeMidDurationInput input){
        SpaceOptimizeMidDurationMapper mapper = context.getBean(SpaceOptimizeMidDurationMapper.class);
        QueryWrapper<SpaceOptimizeMidDurationEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeMidDurationEnt::getId, input.getId());
        SpaceOptimizeMidDurationEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteSpaceOptimizeMidDuration(XContext context, DeleteSpaceOptimizeMidDurationInput input){
        SpaceOptimizeMidDurationMapper mapper = context.getBean(SpaceOptimizeMidDurationMapper.class);
        QueryWrapper<SpaceOptimizeMidDurationEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeMidDurationEnt::getId, input.getId());
        SpaceOptimizeMidDurationEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceOptimizeMidDurationOutput> getSpaceOptimizeMidDuration(XContext context, GetSpaceOptimizeMidDurationInput input){
        SpaceOptimizeMidDurationMapper mapper = context.getBean(SpaceOptimizeMidDurationMapper.class);
        QueryWrapper<SpaceOptimizeMidDurationEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(SpaceOptimizeMidDurationEnt::getId, input.getId());
        SpaceOptimizeMidDurationEnt entity = mapper.selectOne(queryWrapper);
        if(entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceOptimizeMidDurationOutput output = new GetSpaceOptimizeMidDurationOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeMidDurationOutput> querySpaceOptimizeMidDuration(XContext context, QuerySpaceOptimizeMidDurationInput input){
        SpaceOptimizeMidDurationMapper mapper = context.getBean(SpaceOptimizeMidDurationMapper.class);
        QueryWrapper<SpaceOptimizeMidDurationEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(SpaceOptimizeMidDurationEnt::getId, input.getId())
            .eq(SpaceOptimizeMidDurationEnt::getIsDeleted, input.getIsDeleted())
            .like(SpaceOptimizeMidDurationEnt::getCreateById, input.getCreateById())
            .like(SpaceOptimizeMidDurationEnt::getCreateByName, input.getCreateByName())
            .eq(SpaceOptimizeMidDurationEnt::getCreateTime, input.getCreateTime())
            .like(SpaceOptimizeMidDurationEnt::getModifyById, input.getModifyById())
            .like(SpaceOptimizeMidDurationEnt::getModifyByName, input.getModifyByName())
            .eq(SpaceOptimizeMidDurationEnt::getModifyTime, input.getModifyTime())
            .like(SpaceOptimizeMidDurationEnt::getRecordId, input.getRecordId())
            .like(SpaceOptimizeMidDurationEnt::getMidPeriodId, input.getMidPeriodId())
            .like(SpaceOptimizeMidDurationEnt::getWellheadId, input.getWellheadId())
            .eq(SpaceOptimizeMidDurationEnt::getIsOptimize, input.getIsOptimize())
            .like(SpaceOptimizeMidDurationEnt::getGenerationTypeKey, input.getGenerationTypeKey())
            .like(SpaceOptimizeMidDurationEnt::getOpenWellTime, input.getOpenWellTime())
            .like(SpaceOptimizeMidDurationEnt::getCloseWellTime, input.getCloseWellTime());
        return MapperHelper.query(mapper, input, queryWrapper, QuerySpaceOptimizeMidDurationOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeMidDurationOutput> dynamicQuerySpaceOptimizeMidDuration(XContext context, CustomQueryInput input){
        SpaceOptimizeMidDurationMapper mapper = context.getBean(SpaceOptimizeMidDurationMapper.class);
        return MapperHelper.query(mapper, input, SpaceOptimizeMidDurationEnt.class, QuerySpaceOptimizeMidDurationOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetSpaceOptimizeMidDurationViewOutput> getSpaceOptimizeMidDurationView(XContext context, GetSpaceOptimizeMidDurationViewInput input){
        SpaceOptimizeMidDurationViewMapper mapper = context.getBean(SpaceOptimizeMidDurationViewMapper.class);
        SpaceOptimizeMidDurationView record = new SpaceOptimizeMidDurationView();
        XCopyUtils.copyObject(input, record);
        SpaceOptimizeMidDurationView view = mapper.selectOne(record);
        if(view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetSpaceOptimizeMidDurationViewOutput output = new GetSpaceOptimizeMidDurationViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QuerySpaceOptimizeMidDurationViewOutput> querySpaceOptimizeMidDurationView(XContext context, QuerySpaceOptimizeMidDurationViewInput input){
        SpaceOptimizeMidDurationViewMapper mapper = context.getBean(SpaceOptimizeMidDurationViewMapper.class);
        SpaceOptimizeMidDurationView record = new SpaceOptimizeMidDurationView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<SpaceOptimizeMidDurationView> list = mapper.selectList(record);
        PageInfo<SpaceOptimizeMidDurationView> pageInfo = new PageInfo<>(list);
        List<QuerySpaceOptimizeMidDurationViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QuerySpaceOptimizeMidDurationViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
